























































































































 


































































































































































 























































































































































































 





















































 










 








































































































































































































































 










                                
                                

                                
                                

                                
                                

                                





































module cctk_Comm
  implicit none

  interface

     subroutine CCTK_SyncGroup (ierr, GH, group)
       implicit none
       integer               ierr
       integer*8 GH
       character(*)          group
     end subroutine CCTK_SyncGroup

     subroutine CCTK_Barrier (ierr, GH)
       implicit none
       integer               ierr
       integer*8 GH
     end subroutine CCTK_Barrier

















     subroutine CCTK_ParallelInit (ierr, GH)
       implicit none
       integer               ierr
       integer*8 GH
     end subroutine CCTK_ParallelInit

     subroutine CCTK_Exit (ierr, GH, retval)
       implicit none
       integer      ierr
       integer*8 GH
       integer      retval
     end subroutine CCTK_Exit

     subroutine CCTK_Abort (ierr, GH, retval)
       implicit none
       integer      ierr
       integer*8 GH
       integer      retval
     end subroutine CCTK_Abort

     subroutine CCTK_SetupGH (GH, config, convergence_level)
       implicit none
       integer*8 GH
       integer*8 config
       integer      convergence_level
     end subroutine CCTK_SetupGH



     subroutine CCTK_QueryGroupStorageB (ierr, GH, group, groupname)
       implicit none
       integer               ierr
       integer*8 GH
       integer               group
       character(*)          groupname
     end subroutine CCTK_QueryGroupStorageB

     subroutine CCTK_GroupDynamicData (ierr, GH, group, data)
       implicit none
       integer               ierr
       integer*8 GH
       integer               group
       integer*8          data
     end subroutine CCTK_GroupDynamicData

     subroutine CCTK_GroupStorageIncrease &
          (ierr, GH, n_groups, groups, timelevels, status)
       implicit none
       integer               ierr
       integer*8 GH
       integer               n_groups
       integer               groups(n_groups)
       integer               timelevels(n_groups)
       integer               status(n_groups)
     end subroutine CCTK_GroupStorageIncrease

     subroutine CCTK_GroupStorageDecrease &
          (ierr, GH, n_groups, groups, timelevels, status)
       implicit none
       integer               ierr
       integer*8 GH
       integer               n_groups
       integer               groups(n_groups)
       integer               timelevels(n_groups)
       integer               status(n_groups)
     end subroutine CCTK_GroupStorageDecrease

     subroutine CCTK_InterpGridArrays           &
          (ierr,                                &
           GH,                                  &
           N_dims,                              &
           local_interp_handle,                 &
           param_table_handle,                  &
           coord_system_handle,                 &
           N_interp_points,                     &
             interp_coords_type,                &
             interp_coords,                     &
           N_input_arrays,                      &
             input_array_indices,               &
           N_output_arrays,                     &
             output_array_types,                &
             output_arrays)
       implicit none
       integer               ierr
       integer*8 GH
       integer               N_dims
       integer               local_interp_handle
       integer               param_table_handle
       integer               coord_system_handle
       integer               N_interp_points
       integer                 interp_coords_type
       integer*8   interp_coords(N_dims)
       integer               N_input_arrays
       INTEGER*4                input_array_indices(N_input_arrays)
       integer               N_output_arrays
       INTEGER*4                output_array_types(N_output_arrays)
       integer*8            output_arrays(N_output_arrays)
     end subroutine CCTK_InterpGridArrays

     subroutine CCTK_QueryGroupStorage (ierr, GH, groupname)
       implicit none
       integer               ierr
       integer*8 GH
       character(*)          groupname
     end subroutine CCTK_QueryGroupStorage

     subroutine CCTK_QueryGroupStorageI (ierr, GH, group)
       implicit none
       integer               ierr
       integer*8 GH
       integer               group
     end subroutine CCTK_QueryGroupStorageI




  end interface

end module cctk_Comm
